/* Chill a cache. */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <limits.h>

int main(int argc, char *argv[]) {
	char *memarea;
	unsigned long long csize = 0;
	unsigned long long size = 1;
	int offset = 4096;
	int i;
	unsigned long long lsize;

	while((memarea = (char *)malloc(size))) {
		csize += size;
		printf("Allocated %llu bytes (%llu).\n", size, csize);
		for (i = 0; i < size; i += offset) {
			memarea[i] = 0x5a;
		}
		printf("Wrote area.\n");
		size *= 2;
	}

	lsize = size;
	size /= 2;
	do
	{
		if((memarea = (char *)malloc(lsize))) {
			printf("Allocated %llu + %llu = %llu\n", csize, lsize, csize + lsize);
			for(i = 0; i < lsize; i += offset) {
				memarea[i] = 0x5a;
			}
			csize += lsize;
			printf("Wrote memory!.\n");
		} else {
			lsize /= 2;
			printf("Left over size down to %llu\n", lsize);
		}
		printf("HI");
	}
	while(lsize > 1);

	printf("Really allocated %llu bytes.\n", csize);
	perror("malloc()");

	exit(0);
}
